\documentclass[a4paper]{article}

\usepackage[english]{babel} 
\usepackage[utf8x]{inputenc}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{graphicx}
\usepackage[usenames,dvipsnames]{color}
\usepackage{enumitem}
\usepackage{tcolorbox}
\usepackage[top=3cm, bottom=2cm, left=4cm , right=1.5cm]{geometry}

\usepackage{tikz}

\DeclareMathOperator*{\argmax}{arg\,max}
\DeclareMathOperator*{\arginf}{arg\,inf}
\DeclareTextFontCommand{\helvetica}{\fontfamily{phv}\selectfont}
\DeclareTextFontCommand{\courrier}{\fontfamily{pcr}\selectfont}

\setlength{\parindent}{0pt}

\begin{document}

\begin{center}
\begin{tikzpicture}
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H1t) at (1,6) {\tiny{$H_1^1$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H2t) at (1,4) {\tiny{$H_2^1$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H3t) at (1,2) {\tiny{$H_3^1$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H4t) at (1,0) {\tiny{$H_4^1$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H1tt) at (4,6) {\tiny{$H_1^2$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H2tt) at (4,4) {\tiny{$H_2^2$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H3tt) at (4,2) {\tiny{$H_3^2$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H4tt) at (4,0) {\tiny{$H_4^2$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H1ttt) at (7,6) {\tiny{$H_1^3$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H2ttt) at (7,4) {\tiny{$H_2^3$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H3ttt) at (7,2) {\tiny{$H_3^3$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H4ttt) at (7,0) {\tiny{$H_4^3$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O1tt) at (3,7) {\tiny{$O_1^2$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O2tt) at (3,5) {\tiny{$O_2^2$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O3tt) at (3,3) {\tiny{$O_3^2$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O4tt) at (3,1) {\tiny{$O_4^2$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O1ttt) at (6,7) {\tiny{$O_1^3$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O2ttt) at (6,5) {\tiny{$O_2^3$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O3ttt) at (6,3) {\tiny{$O_3^3$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O4ttt) at (6,1) {\tiny{$O_4^3$}};

\node[draw,rectangle,minimum width=0.2cm] (f1) at (0,6) {\tiny{f1}};
\node[draw,rectangle,minimum width=0.2cm] (f2) at (0,4) {\tiny{f2}};
\node[draw,rectangle,minimum width=0.2cm] (f3) at (0,2) {\tiny{f3}};
\node[draw,rectangle,minimum width=0.2cm] (f4) at (0,0) {\tiny{f4}};
\draw[-,>=latex] (f1) -- (H1t);
\draw[-,>=latex] (f2) -- (H2t);
\draw[-,>=latex] (f3) -- (H3t);
\draw[-,>=latex] (f4) -- (H4t);

\node[draw,rectangle,minimum width=0.2cm] (f5) at (2.5,6) {\tiny{f5}};
\node[draw,rectangle,minimum width=0.2cm] (f6) at (2.5,4) {\tiny{f6}};
\node[draw,rectangle,minimum width=0.2cm] (f7) at (2.5,2) {\tiny{f7}};
\node[draw,rectangle,minimum width=0.2cm] (f8) at (2.5,0) {\tiny{f8}};
\draw[-,>=latex] (H1t) -- (f5);\draw[-,>=latex] (H2t) -- (f5);\draw[-,>=latex] (H3t) -- (f5);\draw[-,>=latex] (f5) -- (H1tt);
\draw[-,>=latex] (H2t) -- (f6);\draw[-,>=latex] (H1t) -- (f6);\draw[-,>=latex] (H4t) -- (f6);\draw[-,>=latex] (f6) -- (H2tt);
\draw[-,>=latex] (H3t) -- (f7);\draw[-,>=latex] (H1t) -- (f7);\draw[-,>=latex] (H4t) -- (f7);\draw[-,>=latex] (f7) -- (H3tt);
\draw[-,>=latex] (H4t) -- (f8);\draw[-,>=latex] (H2t) -- (f8);\draw[-,>=latex] (H3t) -- (f8);\draw[-,>=latex] (f8) -- (H4tt);

\node[draw,rectangle,minimum width=0.2cm] (f9) at (5.5,6) {\tiny{f9}};
\node[draw,rectangle,minimum width=0.2cm] (f10) at (5.5,4) {\tiny{f10}};
\node[draw,rectangle,minimum width=0.2cm] (f11) at (5.5,2) {\tiny{f11}};
\node[draw,rectangle,minimum width=0.2cm] (f12) at (5.5,0) {\tiny{f12}};
\draw[-,>=latex] (H1tt) -- (f9);\draw[-,>=latex] (H2tt) -- (f9);\draw[-,>=latex] (H3tt) -- (f9);\draw[-,>=latex] (f9) -- (H1ttt);
\draw[-,>=latex] (H2tt) -- (f10);\draw[-,>=latex] (H1tt) -- (f10);\draw[-,>=latex] (H4tt) -- (f10);\draw[-,>=latex] (f10) -- (H2ttt);
\draw[-,>=latex] (H3tt) -- (f11);\draw[-,>=latex] (H1tt) -- (f11);\draw[-,>=latex] (H4tt) -- (f11);\draw[-,>=latex] (f11) -- (H3ttt);
\draw[-,>=latex] (H4tt) -- (f12);\draw[-,>=latex] (H2tt) -- (f12);\draw[-,>=latex] (H3tt) -- (f12);\draw[-,>=latex] (f12) -- (H4ttt);

\node[draw,rectangle,minimum width=0.2cm] (f13) at (3.5,6.5) {\tiny{f13}};
\node[draw,rectangle,minimum width=0.2cm] (f14) at (3.5,4.5) {\tiny{f14}};
\node[draw,rectangle,minimum width=0.2cm] (f15) at (3.5,2.5) {\tiny{f15}};
\node[draw,rectangle,minimum width=0.2cm] (f16) at (3.5,0.5) {\tiny{f16}};
\node[draw,rectangle,minimum width=0.2cm] (f17) at (6.5,6.5) {\tiny{f17}};
\node[draw,rectangle,minimum width=0.2cm] (f18) at (6.5,4.5) {\tiny{f18}};
\node[draw,rectangle,minimum width=0.2cm] (f19) at (6.5,2.5) {\tiny{f19}};
\node[draw,rectangle,minimum width=0.2cm] (f20) at (6.5,0.5) {\tiny{f20}};
\draw[-,>=latex] (O1tt) -- (f13);\draw[-,>=latex] (H1tt) -- (f13);
\draw[-,>=latex] (O2tt) -- (f14);\draw[-,>=latex] (H2tt) -- (f14);
\draw[-,>=latex] (O3tt) -- (f15);\draw[-,>=latex] (H3tt) -- (f15);
\draw[-,>=latex] (O4tt) -- (f16);\draw[-,>=latex] (H4tt) -- (f16);
\draw[-,>=latex] (O1ttt) -- (f17);\draw[-,>=latex] (H1ttt) -- (f17);
\draw[-,>=latex] (O2ttt) -- (f18);\draw[-,>=latex] (H2ttt) -- (f18);
\draw[-,>=latex] (O3ttt) -- (f19);\draw[-,>=latex] (H3ttt) -- (f19);
\draw[-,>=latex] (O4ttt) -- (f20);\draw[-,>=latex] (H4ttt) -- (f20);
\end{tikzpicture}
\end{center}


\end{document}
